#include <dos.h>

#include "systypes.h"
#include "biosdisk.h"
#include "debug.h"

union    REGS    regsin,regsout;
struct   SREGS   regsseg;

#ifdef __BORLANDC__
#pragma warn -par
#endif

/*
 * returns 0 on error, number of sectors on succes
 */
int bios_rsect(uint8 disk, uint8 nsect, uint16 cyl, uint8 sect, uint8 head, void far *data)
{

                /*
                 * the 2 highest bits of a 10 bits cylinder are placed in
                 * the highest 2 bits of CL
                 */
		dprintf(D_BIOS,"bios_rsect, disk:%u, nsect%u, cyl:%u, sect:%u, head%u\n",
			(unsigned) disk,(unsigned) nsect, cyl, (unsigned) sect, (unsigned) head);
        regsin.h.cl=(uint8) ((sect & 0x3F) | ((cyl >> 2) & 0xC0));
        regsin.h.ch=(uint8) (cyl & 0xFF);
        regsin.h.ah=0x02;
        regsin.h.al=nsect;
        regsin.h.dh=head;
        regsin.h.dl=disk+0x80;
        regsin.x.bx=FP_OFF( (char  far *) data);
        regsseg.es=FP_SEG( (char far *) data);



        int86x(0x13,&regsin,&regsout,&regsseg);

		dprintf(D_BIOS,"bios_rsect:%s, disk:%u, nsect%u, cyl:%u, sect:%u, head%u\n",
			regsout.x.cflag?"FAILED":"succes",
			(unsigned) disk,(unsigned) nsect, cyl, (unsigned) sect, (unsigned) head);
		return !regsout.x.cflag;
}


int bios_wsect(uint8 disk, uint8 nsect, uint16 cyl, uint8 sect, uint8 head, void far *data)
{
        return 0;
}


void bios_driveparam(uint8 disk, uint32* cyl, uint32* sec, uint32* head)
{



		regsin.h.ah = 8;
		regsin.h.dl = disk+0x80;
		int86(0x13, &regsin, &regsout);
		if (regsout.x.cflag)
		{
				*sec    = (uint32)  0;
				*cyl    = (uint32) 0;
				*head   = (uint32)  0;
		}
		else
		{
				*sec    = (uint32) (regsout.h.cl & 0x3F) ;
				*cyl    = (uint32) (((uint16) regsout.h.ch) | (((uint16) (regsout.h.cl & 0xC0)) << 2));
				*head   = (uint32) regsout.h.dh + 1 ;
		}
		if (*cyl > (uint32) 1024)
				*cyl= (uint32) 1024;

		dprintf(D_BIOS,"driveparam, disk %u, nr_sec=%u, nr_cyl=%u, nr_head=%u\n",
			(unsigned) disk, (unsigned) *sec, (unsigned) *cyl, (unsigned) *head);


}
#ifdef __BORLANDC__
#pragma warn +par
#endif


