#ifndef __EMSCACHE_H
#define __EMSCACHE_H

#include "ems.h"

/*
 * Buffer chache is used for both blocks & inodes;
 * note that the cache resides completely in ems
 *
 */


typedef struct _cache_entry
{
	unsigned long		item_no;			/* nr of item were are caching: ino ot blockno	*/
	unsigned char		l_unit;				/* logical unit the object belongs to 		  	*/
	unsigned char		level;				/* level 1 or 2									*/
	unsigned			hashindex;
	unsigned			emsIndex;			/* where were put it in ems						*/
	void far			*data;				/* if it's mapped in conv. mem, where it is		*/
	struct _cache_entry *lru_next;			/* they form a cyclic double linked list 		*/
	struct _cache_entry *lru_prev;
	struct _cache_entry	*hash_next;			/* for speedy looking up						*/
	struct _cache_entry	*hash_prev;			/* for speedy looking up						*/
} cache_entry_t;


typedef struct
{
	cache_entry_t	**hash_queue;
	unsigned		hash_size;
	emshandle_t		emsHandle;
	unsigned		nr_items;
	unsigned		size_item;
	cache_entry_t	*lru_head[2];
	cache_entry_t	*cache_list;
	unsigned long	lookups;
	unsigned long	hits;
} buffer_cache_t;



buffer_cache_t* mk_cache(unsigned emsPages,unsigned size_item);
void			dl_cache(buffer_cache_t *bcache);
cache_entry_t* cache_lookup(buffer_cache_t *bcache, unsigned l_unit, unsigned long item_no);
cache_entry_t* cache_add(buffer_cache_t *bcache, unsigned l_unit, unsigned long item_no, void far *data);
void cache_walk(buffer_cache_t *bcache, int level);



#endif		/* __EMSCACHE_H */
